/***********************************************************************
*                                                                      *
*              This software is part of the pads package               *
*           Copyright (c) 2005-2007 AT&T Knowledge Ventures            *
*                         All Rights Reserved                          *
*         This software is licensed by AT&T Knowledge Ventures         *
*           under the terms and conditions of the license in           *
*                    www.padsproj.org/License.html                     *
*                                                                      *
*  This program contains certain software code or other information    *
*  ("AT&T Software") proprietary to AT&T Corp. ("AT&T").  The AT&T     *
*  Software is provided to you "AS IS". YOU ASSUME TOTAL RESPONSIBILITY*
*  AND RISK FOR USE OF THE AT&T SOFTWARE. AT&T DOES NOT MAKE, AND      *
*  EXPRESSLY DISCLAIMS, ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND  *
*  WHATSOEVER, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF*
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, WARRANTIES OF  *
*  TITLE OR NON-INFRINGEMENT.  (c) AT&T Corp.  All rights              *
*  reserved.  AT&T is a registered trademark of AT&T Corp.             *
*                                                                      *
*                   Network Services Research Center                   *
*                          AT&T Labs Research                          *
*                           Florham Park NJ                            *
*                                                                      *
*                 Robert Gruber <bob.gruber@gmail.com>                 *
*              Kathleen Fisher <kfisher@research.att.com>              *
*            Yitzhak Mandelbaum <yitzhakm@cs.princeton.edu>            *
*                                                                      *
***********************************************************************/
//
// These macros are called by the C code that is generated by gigascope_make.pl
//

#ifndef PDCI_MacroArg2String
#define PDCI_MacroArg2String(s) #s
#endif

#define HDR_GET_FN(ty, field) \
int get_pads_ ## field (struct packet *p, ty *r) { \
  if (global_hdr_pd.field.nerr) return -1; \
  *r = (ty)global_hdr.field; \
  return 0; \
}

#define REC_GET_FN(ty, field) \
int get_pads_ ## field (struct packet *p, ty *r) { \
  if (global_rec_pd.field.nerr) return -1; \
  *r = (ty)global_rec.field; \
  return 0; \
}

#define HDR_GET_STR_FN(ty, field) \
int get_pads_ ## field (struct packet *p, struct string *r) { \
  if (global_hdr_pd.field.nerr) return -1; \
  r->data = global_hdr.field.str; \
  r->length = global_hdr.field.len; \
  r->owner = 0; \
  return 0; \
}

#define REC_GET_STR_FN(ty, field) \
int get_pads_ ## field (struct packet *p, struct string *r) { \
  if (global_rec_pd.field.nerr) return -1; \
  r->data = global_rec.field.str; \
  r->length = global_rec.field.len; \
  r->owner = 0; \
  return 0; \
}

